package cz.frantovo.hrisniciSpameri.grafy;

import cz.frantovo.hrisniciSpameri.DenniSouhrn;
import cz.frantovo.hrisniciSpameri.dto.Soucet;
import de.laures.cewolf.DatasetProduceException;
import de.laures.cewolf.DatasetProducer;
import de.laures.cewolf.links.CategoryItemLinkGenerator;
import de.laures.cewolf.tooltips.CategoryToolTipGenerator;
import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.time.Day;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.time.TimeSeriesCollection;
import org.jfree.data.xy.XYDataset;

/**
 *
 * @author fiki
 */
public class CasovyGrafUtoku implements DatasetProducer, CategoryToolTipGenerator, CategoryItemLinkGenerator, Serializable {

    private static final long serialVersionUID = -9133218147909088777L;

    public XYDataset produceDataset(Map parametry) throws DatasetProduceException {

        DenniSouhrn ds = new DenniSouhrn();
        ds.setZacatekString(String.valueOf(parametry.get("zacatek")));
        ds.setKonecString(String.valueOf(parametry.get("konec")));
        ds.setCilString(String.valueOf(parametry.get("cil")));

        HashMap<Integer, TimeSeries> casoveRady = new HashMap<Integer, TimeSeries>();

        for (Collection<Soucet> ss : ds.getSoucty().values()) {

            for (Soucet s : ss) {
                if (casoveRady.get(s.getCil().getId()) == null) {
                    casoveRady.put(s.getCil().getId(), new TimeSeries(s.getCil().getNazev(), org.jfree.data.time.Day.class));
                }
                casoveRady.get(s.getCil().getId()).add(new Day(s.getDen()), s.getPocet());
            }
        }

        TimeSeriesCollection dataset = new TimeSeriesCollection();
        for (TimeSeries ts : casoveRady.values()) {
            dataset.addSeries(ts);
        }

        return dataset;
    }

    public boolean hasExpired(Map params, Date since) {
        return (System.currentTimeMillis() - since.getTime()) > 5000;
    }

    public String getProducerId() {
        return this.getClass().getSimpleName();
    }

    public String generateToolTip(CategoryDataset data, int series, int item) {
        return "";
    }

    public String generateLink(Object dataset, int series, Object category) {
        return "";
    }
}
